/* IN PROCESS OF CHANGING TO Parallel Multip. Precision    */
/* converting miarith.cs to pmiarith.cs                    */


/*  Multiple precision integer arithmetic - see multip1.notes	*/
/*  This file has addition, subtraction, multiplication, and	*/
/*  utility routines.  See midiv.c  for division.		*/
/*  Source:  miarith.c		Header:  miarith.h		*/
/*  Ernest Sibert -- May 1995					*/

#include <stdio.h>
#include "multip.h"

/* -------------------------------------------------------------------- */

/*  Integer  d := x + y, may overflow	*/
/*  d == x or d == y is permitted.	*/

void pimadd(int:current d[], int:current x[], int:current y[], int N)
 { int i; int:current cy, w, nz, xs, ys;
   xs = x[0];  ys = y[0];		/* Status words */
   cy = nz = 0;				/* Carry value, non-zero detector */
   where ( (xs|ys)&Ovflw ) 		/* Overflow in input(s)	*/
      d[0] = Ovflw;
   else					/* A real addition	*/
    { for ( i = N;  i > 0;  i-- )
       { w  = x[i] + y[i] + cy;
	 cy = ( w&Bcy ) ? 1 : 0;  w &= Bwrd;
	 d[i] = w;  nz |= w;
       }
      /* Result status - Nonzr Ovflw Sign */
      w = (((xs&Sign) + (ys&Sign) + cy)^(cy<<1)) | (nz > 0)<<2;
      where ( w&Sign ) w |= Bneg;		/* Fill in neg. sign */
      d[0] = w;
    }
 }

/* -------------------------------------------------------------------- */

/*  Integer  d := -n, may overflow	*/
/*  d == x is permitted.		*/

void pimneg(int:current d[], int:current x[], int N)
 { int i; int:current cy, w, nz, xs;
   xs = x[0];  cy = 1;  nz = 0;
   where ( xs&Ovflw )  d[0] = Ovflw;
   else
    { for ( i = N;  i > 0;  i-- )
       { w  = ((~x[i])&Bwrd) + cy;
	 cy = ( w&Bcy ) ? 1 : 0;  w &= Bwrd;
	 d[i] = w;  nz |= w;
       }
      /* Result status - Nonzr Ovflw Sign */
      w = ((((~xs)&Sign) + cy)^(cy<<1)) | (nz > 0)<<2;
      where ( w&1 ) w |= Bneg;		/* Fill in neg. sign */
      d[0] = w;
    }
 }

/* -------------------------------------------------------------------- */

/*  Integer  d := x - y, may overflow	*/
/*  d == x or d == y is permitted.	*/

void pimsub(int:current d[], int:current x[], int:current y[], int N)
 { int i;
   int:current w, xs, ys, cy, nz;
   xs = x[0];  ys = y[0];		/* Status words */
   cy = 1;  nz = 0;			/* Carry value, non-zero detector */

   where ( (xs|ys)&Ovflw ) d[0] = Ovflw;	/* Overflow in input(s)	*/
   else					/* A real subtraction	*/
    { for ( i = N;  i > 0;  i-- )
       { w  = x[i] + ((~y[i])&Bwrd) + cy;
	 cy = ( w&Bcy ) ? 1 : 0;  w &= Bwrd;
	 d[i] = w;  nz |= w;
       }
      /* Result status - Nonzr Ovflw Sign */
      w = (((xs&Sign) + ((~ys)&Sign) + cy)^(cy<<1)) | (nz > 0)<<2;
      where ( w&1 ) w |= Bneg;		/* Fill in neg. sign */
      d[0] = w;
    }
 }

/* -------------------------------------------------------------------- */

/*  d := x for multiple-precision	*/
/*  d == x is permitted but silly..	*/

void pmcopy(int:current d[], int:current x[], int N)
 { int i;
   for ( i = 0;  i <= N;  i++ )  d[i] = x[i];
 } 

/* -------------------------------------------------------------------- */

/*  d := 0 for multiple-precision	*/

void pmzero(int:current d[], int N)
 { int i;
   for ( i = 0;  i <= N;  i++ )  d[i] = 0;
 }     

/* -------------------------------------------------------------------- */

/*  Integer  dd[0..M+N] := x[0..M]*y[0..N], for	*/ 
/*  x >= 0 and y >= 0, whence result is >= 0.	*/ 
/*  Neither x nor y should interfere with dd.	*/ 
/*  Overflow is impossible.			*/ 
/*  M = 1, N > 1 is better than M > 1, N = 1 if	*/ 
/*  either case is likely.			*/ 


 /* NOT DONE---------deleted pimult2x here (goes below)******** */ 

/*****************Entire Funct.- pimult2x (above) deleted out ********* */ 

  /**************************************************************/
  /* When multiplying x[i]*y[j],  k = i+j:			*/
  /*								*/
  /*   31   29     15 14      0     31   29     15 14      0	*/
  /*                      cy(in)				*/
  /*  +------------------------+   +------------------------+   */
  /*  |   0|      dd[k-1]      |   |   0|   dd[k] = w0      |	*/
  /*  +------------------------+   +------------------------+   */
  /*                               +------------------------+   */
  /*                               |   0|   p0    :         |	*/
  /*                               +------------------------+   */
  /*            +---------------........----------+       	*/
  /*            |   c|         :  p1    :         |		*/
  /*            +---------------........----------+		*/
  /*  +------------------------+				*/
  /*  |   0|    p2   :         |				*/
  /*  +------------------------+				*/
  /*  cy(out)							*/
  /*								*/
  /*  Note that cy(in) = 0 when j = N				*/
  /*       and cy(out) = 0 when	j = 1				*/
  /**************************************************************/

/* -------------------------------------------------------------------- */

/*  Integer  dd[0..M+N] := x[0..M]*y[0..N]			*/
/*  Multiplication by the most negative integer yelds overflow,	*/
/*  all other cases succeed without overflow.			*/
/*  This program buffers x and y, hence is not sensitive to	*/
/*  interference.						*/


/* DELETED pimult2 here (below) *********************************/ 

/*..*************ABOVE FUNCT. -pimult2  DELETED OUT **********  */

/* -------------------------------------------------------------------- */

/*  x[0..N] := s*x[0..N] + d  where  x >= 0 and  0 <= d < s < 2^Mhalf .	*/
/*  May overflow							*/

void pimmuls(int:current x[], int N, int s, int d)
 { int i; int:current xlo, xhi , cy, nzr;
   cy = d;  nzr = 0;
   for ( i = N;  i >= 1;  i-- )
    { xlo = x[i];  xhi = (xlo&Bhi)>>Mhalf;  xlo &= Blo;
      xlo = s*xlo + cy;
       cy = (xlo&Bhi)>>Mhalf;  xlo &= Blo;
      xhi = s*xhi + cy;
       cy = (xhi&Bhi)>>Mhalf;  xhi &= Blo;
      xhi = (xhi<<Mhalf) | xlo;
      nzr |= xhi;  x[i] = xhi;
    }
   x[0] |= ((nzr > 0)<<2) | ((cy > 0)<<1);
 } 

/* -------------------------------------------------------------------- */

/*  Shift, d := x*2^e, may generate overflow.	*/
/*  d[0..N] should not interfere with x[0..N].	*/

void pimshift(int:current d[], int:current x[], int e, int N)
 { int swrds, sbits, ae, sbdwn, i, j, u, mask;
   int:current fill, w, nzr, ds, up;
   ae = abs(e);  swrds = ae/Mword;  sbits = ae%Mword;  sbdwn = Mword - sbits;
   if ( swrds > N ) swrds = N;
   ds = x[0];			/* Status */
   fill = ( ds&Sign ) ? Bwrd : 0;
   if ( e <= 0 )	/* Shift right */
    { for ( i = 1; i <= swrds; i++ ) d[i] = fill;
      nzr = ( 1 <= swrds ) ? fill : 0;	/* To check for non-zero bits	 */
      mask = Bwrd>>sbdwn;		/* Bits which cross word	 */
      fill = (fill&mask)<<sbdwn;	/* For first word with data	 */
      for ( j = 1 ; i <= N; i++, j++ )	/* Fill words which receive data */
       { w    = x[j];
	 d[i] = up = (w>>sbits) | fill;  nzr |= up;
	 fill = (w&mask)<<sbdwn;		/* To next word	*/
       }
    }	/* end of case e <= 0 */
   else	/* shift left */
    { u = N - swrds;		/* To fill 0 words at right */
      for ( i = N;  i > u;  i-- ) d[i] = 0;
      mask = Bwrd>>sbits;		/* Bits which stay in word	 */
      nzr = 0;  up = 0;
      for ( j = N;  i >= 1;  i--, j-- )	/* Fill words which receive data */
       { w    = x[j];
         d[i] = up = ((w&mask)<<sbits) | up;  nzr |= up;
	  up = w>>sbdwn;			/* To next word */
       }
      up ^= (fill>>sbdwn);		/* To check for overflow */
      for (  ;  j >= 1;  j-- ) u |= (x[j]^fill);
      where ( up ) ds |= Ovflw;
    }
   where ( nzr ) ds |= Nonzr; else ds &= ~Nonzr;
   d[0] = ds;
 }

/* -------------------------------------------------------------------- */

/*  Report status of mp quantity as:		*/
/*       4   overflow				*/
/*	 1   positive				*/
/*	 0   zero				*/
/*	-1   negative, but not most negative	*/
/*	-2   most negative integer 		*/

int:current pimstat(int:current x[])

 { int:current xs;
   xs = x[0];
   return ( xs&Ovflw ) ? 4 : xs>>2;
 }

/* -------------------------------------------------------------------- */

/*  Compare mp integers x, y, result is:	*/
/*	 4   overflow ( x or y has overflow)	*/
/*	 1   x > y				*/
/*       0   x = y				*/
/*	-1   x < y				*/


int:current pimcomp(int:current x[], int:current y[], int N)
 { int i; int:current xs, ys,result;
   result=0;
   xs = x[0];  ys = y[0];
   where ( (xs|ys)&Ovflw) result = 4;
   for ( i = 0;  i <= N;  i++ )
    where (( x[i] > y[i] )& !result) result =  1; else
    where (( x[i] < y[i] )& !result) result = -1;
   return (result);
 }




/* ALL FUNCTIONS BEYOND THIS POINT HAVE NOT BEEN CONVERTED TO PARALLEL */
/* YET                                  ---      ---------             */

/* AND HAVE BEEN DELETED OUT UNTIL CONVERSION ***************/   

/* -------------------------------------------------------------------- */

/*  Determine position of leading 1 in x, relative to mp words	*/
/*  Positions are counted from top.				*/
/*  Example for 32-bit machine word, 30 bits mp:		*/
/*								*/
/*            0   1   2   3   4   5   6   7   8			*/
/*  +---+---+---+---+---+---+---+---+---+---+---+ . . .		*/
/*  | 0 | 0 | 0 | 0 | 0 | 0 | 0 | 1 | 0 | 1 | 1 |		*/
/*  +---+---+---+---+---+---+---+---+---+---+---+ . . .		*/
/*    31  30  29  28  27  26  25  24  23  22  21		*/
/*								*/
/*  The result is 5, which is the left-shift to normalize.	*/

/* FUNCTION Bitpos DELETED (GOES BELOW)  */ 

/* Bitpos deleted from above...*******   */ 
/* -------------------------------------------------------------------- */

/*  Normalize x > 0 so that x[1] >= (1/2)*s^Wsize [ 2^29 ]	*/
/*  Returns number of bits required for shift.  Returns -1 if	*/
/*  x <= 0.							*/

/* FUNCTION imnorm DELETED (goes below)  ***/ 
